
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define EPS (1E-6)
#define EQ(x,y) (fabs((x)-(y))<EPS)
#define LT(x,y) ((x)+EPS < (y))
int index_of(int q, vector<int> &bs){
	for(int i=0;i+1<bs.size();i++){
		if(bs[i] < q && q < bs[i+1])
			return i;
	}
	throw 0;
}
double height_of(int idx, vector<int> &bs,vector<double> &ws){
	return ws[idx]/(bs[idx+1]-bs[idx])/30;
}
int main(void){
	int cases;
	cin >> cases;
	while(cases--){
		int n;
		vector<int> bs(1,0);
		vector<int> hs(1,50);
		int d;
		cin >> d;
		while(d--){
			int b,h;
			cin >> b >> h;
			bs.push_back(b);
			hs.push_back(h);
		}
		bs.push_back(100);
		hs.push_back(50);
		n = bs.size()-1;
		vector<int> fs(n,0);
		vector<double> ws(n,0.0);
		cin >> d;
		while(d--){
			int f,a;
			cin >> f >> a;
			fs[index_of(f,bs)] += a;
		}
		cin >> d;
		vector<pair<pair<int,int>,int > > events(d);
		vector<double> ans(d);
		for(int i=0;i<d;i++){
			int p,t;
			cin >> p >> t;
			events[i] = make_pair(make_pair(t,p),i);
		}
		sort(events.begin(), events.end());
		double t = 0.0;
		int cur = 0;
		while(cur != d){
			double nt = 1E10;
			if(n != 1)
				for(int i=0;i<n;i++)
					if(fs[i] != 0)
						nt = min(nt, t+((bs[i+1]-bs[i])*30*min(hs[i+1],hs[i])-ws[i])/fs[i]);
			nt = min(nt, (double)events[cur].first.first);
			for(int i=0;i<n;i++)
				ws[i] += fs[i]*(nt-t);
			if(EQ(nt,events[cur].first.first)){
				int idx = index_of(events[cur].first.second, bs);
				ans[events[cur].second] = min(50.0,height_of(idx,bs,ws));
				cur++;
			}
			for(int i=0;i<n;i++){
				double h = height_of(i, bs, ws);
				if(!EQ(h, hs[i])&&!EQ(h,hs[i+1])) continue;
				int trg = EQ(h,hs[i])?i-1:i+1;
				if(EQ(height_of(trg, bs, ws),h)){
					int idx = min(trg, i);
					fs[idx] += fs[idx+1];
					ws[idx] += ws[idx+1];
					fs.erase(fs.begin()+idx+1);
					ws.erase(ws.begin()+idx+1);
					bs.erase(bs.begin()+idx+1);
					hs.erase(hs.begin()+idx+1);
					n--;
				}else{
					fs[trg] += fs[i];
					fs[i] = 0;
				}
			}
			t = nt;
		}
		for(int i=0;i<d;i++)
			cout << fixed << setprecision(3) << ans[i] << endl;
	}
	return 0;
}
